#include "chess.h"
#include "data.h"

bool cBOARD::incheck(){
		return ((control[pieces[side][0]] & mask[side]) > 0);
	}

void cBOARD::display()
{
    char pc[]="KQRBNP ";
    char le[]="87654321";
    
    const unsigned char grey = 178;
    const unsigned char white = 177;
    const unsigned char other = 176;
    unsigned char fil[][3]={white, white, 0, grey, grey, 0, other, white, 0, other, grey, 0};
    int sq;//, v; // z
    unsigned char s;
    
    cout << "\n    a    b    c    d    e    f    g    h               WHITE\tBLACK\n";
    for(int r=0; r<8; r++)
    {
        cout << le[r]<< " ";
        for(int c=0; c<8; c++)
        {
             sq=r*16+c;
             s=((r+c)&1) ? grey : white;
             if(square[sq].ptype!=EMPTY) s= pc[square[sq].ptype];
             cout << fil[(r+c)&1] << s << fil[(r+c)&1];  //
        }
        cout << " " << le[r] << " ";
        
        //cout << ti[z] << "\t" << spec[WHITE][z] << "\t" << spec[BLACK][z];
        cout << "\n  ";
        //z++;
        for(int c=0; c<8; c++)
        {
             sq=r*16+c;
             s=((r+c)&1) ? grey : white;
             if(square[sq].color!=NONE) s=square[sq].color;
             if(square[sq].color==WHITE) s=255;
             if(square[sq].color==BLACK) s=219;
             
             /*
             //if(control[sq] & 0x0000ffff)
			 if(control[sq] & 0xffff0000)
                 cout << fil[2+((r+c)&1)] << s << fil[(r+c)&1];
             else
             //*/
             cout << fil[(r+c)&1] << s << fil[(r+c)&1];  //
              
        }
        /*
        cout << "   ";
        cout << ti[z] << "\t" << spec[WHITE][z] << "\t" << spec[BLACK][z];
        */
        cout << "\n";
        //z++;
    }
    cout << "    a    b    c    d    e    f    g    h \n";
}
