#include "chess.h"
#include "data.h"
#include <fstream>
#include <string>

#ifdef _LINUX
#include <string.h>
#endif

int eval_suite(char *fn){
    int v;//, i = 0;
    //char * le;
	char line[FILENAME_MAX] = ".\\tests\\";
	if (strchr(fn, '\\') == 0)
        strcat(line, fn);
	else
		strcpy(line, fn);
	if (strstr(line, ".epd") == 0 && strstr(line, ".EPD") == 0 && strstr(line, ".Epd") == 0)
        strcat(line, ".epd");
    //char answer[8];
    //cMOVE m;
    ifstream infile;
    infile.open(line);
    if (!infile.is_open()){
        cout << "couldnt open file!";
        return(0);
    }
    ofstream ofile;
    ofile.open(".\\tests\\evals.epd");
    
    logfile << "locate\tshield\tadjust\tprox\tlats\tpawns\ts\ttotal\n";
    
    //while(!infile.eof()){
    while(1){
        infile.getline(line, sizeof line, '\n');
        if(infile.eof()) break;
        if(line[0] == '#') continue; // remark
        //if(strstr(line, "xh7") == NULL) continue;
        board.setup(line);
        board.display();
        //hashtable.clear(); //done in setboard()
        
        for(int x = 0; x < 128; x++){
            for(int y = 0; y < 128; y++){
                historic[WHITE][x][y] = 0;//historic[WHITE][x][y] >> 1;
                historic[BLACK][x][y] = 0;//historic[BLACK][x][y] >> 1;
            }
        }
        cout << line << endl;
        //if(side == BLACK)
        v = board.evaluate();
        if(side == BLACK) v = -v; //from white's perspective
        ofile << v << endl; 
    }
    infile.close();
    ofile.close();
	return 1;
}

