#include "chess.h"
#include "data.h"

void cPHASHTABLE::clear(){
    unsigned int i = 0;
    do{
        table[i].lock = 0;
        table[i].wliability = 0;
        table[i].bliability = 0;
        table[i].wpps = 0;
        table[i].bpps = 0;
		table[i].wpassed = 0;
		table[i].bpassed = 0;
        if(i == pawn_hash_table_size) break;
        i++;
    }while(1);
}
        
cPHASHENTRY * cPHASHTABLE::probe(unsigned int pawnkey){
    int i = pawnkey & pawn_hash_table_size;
    return &table[i];
}

