#include "chess.h"
#include "data.h"

void stuff(int draft, int val){
    cMOVE * cm = tree.nextmove[ply-1];
    cMOVE pm;
    pm = pv[1][ply];
    while(cm < tree.nextmove[ply]){ // search current ply move list
        if(pm.is_equal(cm)){ // eureka
            pm.print();
            // replaces entry IFF draft >= entry_depth
            // no indication this is a problem. seconded
            hashtable.store(draft, val, EXACT_PV, cm);
            if(board.domove(cm)){
				if(board.control[board.pieces[side][KING]] & mask[side]){
					//*
					if(mate_search(-NFINITY,NFINITY,0)) cout << "#";
					else//*/
						cout << "+";
				}
                if(/*draft && */ply < pvl[1]){
                    tree.gen();
                    stuff(draft-1, -val);
                }
                board.unmove();
                break;
            }else break;
        }
        cm++;
    }
}

void extract(cMOVE *m){
    pvl[ply] = ply;
	if(!m->is_pseudo()) return; // ok
    if(ply >= MAXPLY-2) return;
    
    if(fifty>3){ // IID
        if(fifty >= move50) return;
        if(board.gamestack.rep()) return;
    }
    cHASHENTRY * he;
    cMOVE t;
    
    if(board.domove(m)){
        he = hashtable.probe();
        if(he != NULL){
            if((he->data & 3) == EXACT_PV){
                t.from = he->bm.from;
                t.to = he->bm.to;
                t.mtype = he->bm.type;
                extract(&t);
            }
        }
        board.unmove();
        /* update the PV */
        pv[ply][ply] = *m;  // 
        for (int j = ply + 1; j < pvl[ply + 1]; ++j)
            pv[ply][j] = pv[ply + 1][j];
        pvl[ply] = pvl[ply + 1];
    }
}                
/*        
    if(!f){
        cHASHENTRY * he = hashtable.probe();
        if(he != NULL){
            pm.from = he->bm.from;
            pm.to = he->bm.to;
            pm.mtype = he->bm.type;
            i = tree.mindex[ply-1];
            while(i < tree.mindex[ply]){
                cm = tree.moves[i];
                if(cm.from == pm.from && cm.to == pm.to && cm.mtype == pm.mtype){
                    //cm.print();
                    if(board.domove(cm)){
                        
                        pv[1][ply] = cm;
                        tree.gen();
                        stuff(-val);
                        board.unmove();
                        break;
                    }else break;
                }
                i++;
            }
        }
    }
}
//*/
            
