#ifndef data_included
#define data_included

extern char buffer[64];
extern ofstream logfile;

extern long nodes;
extern long qnodes;
extern int qdepth;
extern int idepth;
extern int fh1;
extern int fhn;
extern float abf;
extern long st;
extern int root_mat_balance;
extern int rootalpha;
extern int rootbeta;
extern int vbs;
extern int stopsearch;
extern int tot_mt_ext;
extern int tot_ck_ext;
extern int tot_p7_ext;
extern int tot_nm_red;
extern int tot_fut_cut;
extern int tot_nm_fal;
extern int tot_1reply;
extern int tot_delay;
extern int good_delay;
extern int tot_recap_ext;
extern int post;
extern int enpassant;
extern int fifty;
extern int move50;
extern int castle;
extern int side;
extern int xside;
extern int ply;
extern i64 key;
extern int force[2];
extern cMOVE no_move;

extern cBOARD board;
extern cMOVELIST tree;
extern cHASHTABLE hashtable;
extern cPHASHTABLE phashtable;

extern cMOVE pv[MAXPLY][MAXPLY];
extern int pvl[MAXPLY];

extern int forceval[8];
extern int matval[8];
extern int capval[8];
extern int delta[16];
extern unsigned int mask[2];

extern i64 zobrist[2][6][128];
extern i64 zcastle[16];
extern i64 zenpassant[128];

extern int pcsq[6][2][128];
extern int castlemask[128];
extern int p27[128];
extern int outpost[2][128];
extern int piece_home[2][128];
extern int rook_trap[128];
extern int bishop_trap[2][128];
extern int border[128];
extern int center[128];
extern int king_defects[2][128];
//extern int the_scale[128];
//extern int f_scale[64];
//extern int i_scale[64];
extern int e_scale[128];
//extern int p_scale[128];
extern int king_safe[256];
extern int pawn_aggressor[8];
//extern int pawn_shield[8];
extern int passed_pawn[8];
extern int passed_connected[8];
extern int passed_supported[8];
extern int passed_blocked[8];
extern int passed_hidden[8];
extern int freedom[9];
//extern int aggressors[16];
extern int manhattan[256];
extern int pseudoe[256];
extern unsigned int historic[2][128][128];
extern unsigned int maxhist[2];
extern int proxim_val[16];
extern int prox_scale[32];

#endif
