#include "chess.h"
#include "data.h"
#include "weights.h"

int read_ini_file(char *p){
	ifstream pers;
	pers.open(p);
    if (!pers.is_open()){
        cout << "couldnt open ini file!";
        return(0);
    }
	pers >> buffer >> main_hash_entries;
	pers >> buffer >> pawn_hash_entries;

	pers >> buffer >> ks_defect;
	pers >> buffer >> ks_exponent;

	pers >> buffer >> ext_base;
	pers >> buffer >> ext_check;
	pers >> buffer >> ext_p27th;
	pers >> buffer >> ext_mate;
	pers >> buffer >> ext_1reply;
	pers >> buffer >> ext_recap;

	pers >> buffer >> max_pos_value;
	pers >> buffer >> max_pos_gain;
	pers >> buffer >> forked_piece;
	pers >> buffer >> hanging_piece;

	pers >> buffer >> premature_queen;

	pers >> buffer >> rook_restricted;;
	pers >> buffer >> rook_trapped;
	pers >> buffer >> rook_on_7th;
	pers >> buffer >> rook_connected;
	pers >> buffer >> rook_on_open;
	pers >> buffer >> rook_on_hopen;
	pers >> buffer >> rook_behind_passed;

	pers >> buffer >> bishop_trapped;
	pers >> buffer >> bishop_restricted;
	pers >> buffer >> bishop_pair;

	pers >> buffer >> space;

	pers >> buffer >> isolated_pawn;
	pers >> buffer >> doubled_pawn;
	pers >> buffer >> immobile_pawn;
	pers >> buffer >> weak_pawn;
	pers >> buffer >> end_pawn;

	pers >> buffer >> unmoved_piece;

	pers >> buffer >> kings2war;

	pers >> buffer >> shield0;
	pers >> buffer >> shield1;
	pers >> buffer >> shield2;
	pers >> buffer >> shield3;
	pers >> buffer >> shield4;
	pers >> buffer >> shield5;
	pers >> buffer >> shield6;
	pers >> buffer >> ropenbyking;
	pers >> buffer >> rhopenbyking;
	pers >> buffer >> no_escape;

	pers.close();

	/*
	cout << main_hash_entries << endl;
	cout << pawn_hash_entries << endl;

	cout << ks_defect << endl;
	cout << ks_exponent << endl;

	cout << ext_base << endl;
	cout << ext_check << endl;
	cout << ext_p27th << endl;
	cout << ext_mate << endl;
	cout << ext_1reply << endl;
	cout << ext_recap << endl;

	cout << max_pos_value << endl;
	cout << max_pos_gain << endl;
	cout << forked_piece << endl;
	cout << hanging_piece << endl;

	cout << premature_queen << endl;

	cout << rook_restricted << endl;
	cout << rook_trapped << endl;
	cout << rook_on_7th << endl;
	cout << rook_connected << endl;
	cout << rook_on_open << endl;
	cout << rook_on_hopen << endl;
	cout << rook_behind_passed << endl;

	cout << bishop_trapped << endl;
	cout << bishop_restricted << endl;
	cout << bishop_pair << endl;

	cout << space << endl;

	cout << isolated_pawn << endl;
	cout << doubled_pawn << endl;
	cout << immobile_pawn << endl;
	cout << weak_pawn << endl;
	cout << end_pawn << endl;

	cout << unmoved_piece << endl;

	cout << kings2war << endl;

	cout << shield0 << endl;
	cout << shield1 << endl;
	cout << shield2 << endl;
	cout << shield3 << endl;
	cout << shield4 << endl;
	cout << shield5 << endl;
	cout << shield6 << endl;
	cout << ropenbyking << endl;
	cout << rhopenbyking << endl;
	cout << no_escape << endl;//*/

	return 1;
}
	
