#include "chess.h"
#include "data.h"
#include <fstream>
#include <string>

#ifdef _LINUX
#include <string.h>
#endif



int run_suite(char *fn, int maxt, int maxd){
    int i = 0;
    char line[384] = "";
	char answer[16] = "";
	char def_id[] = "i dunno";
    char *id, *bm, *t; //*co, 
    cMOVE m;
    ifstream infile;
    infile.open(fn);
    if (!infile.is_open()){
        cout << "couldnt open file!";
        return 0;
    }
    ofstream ofile, rfile;//, mfile;
    ofile.open(".\\tests\\wrong.epd");
	if(!ofile.is_open()) cout << "/a/a/a";
    rfile.open(".\\tests\\right.epd");
    //mfile.open(".\\tests\\mate.epd");

    i64 total_nodes = 1;
    i64 total_qnodes = 1;
    i64 total_fhn = 1;
    i64 total_fh1 = 1;
    float total_abf = 0;
    float total_depth = 0;
	float start = clock();

    while(1){
        infile.getline(line, 384, '\n');
        if(infile.eof()) break;
        if(line[0] == '#') continue; // remark
		
		id = strstr(line, "id ");
		if(id != NULL){
			t = strchr(id, ';');
			if(t != NULL) *t = 0; // terminate
		}else id = def_id;

		
		if((bm = strstr(line, "bm ")) == NULL) continue; // best move
		*bm = 0;        // strip bm from line

		bm += 3;

		t = strchr(bm, ';');
		if(t != NULL) *t = 0; // strip id from bm AND line
		
        hashtable.clear();
        clear_historic();
        
        cout << ++i << " " << line << " " << bm << " " << id << endl;

        board.setup(line);

        m = think(maxt, 0, maxd, bm); // 
        
        total_nodes += nodes/1000;
        total_qnodes += qnodes/1000;
        total_fhn += fhn;
        total_fh1 += fh1;
        total_depth += idepth;
        total_abf += abf;
        
        m.to_san(answer); //             <-----
        
        cout << answer << endl;
        //*
        if(strstr(bm, answer) == NULL){
		//if(m.score < 0){
            cout << "\a";
            ofile << line << "bm " << bm << "; " << id << ";\n"; 
        }
        else{
            //if(m.score == 9991) mfile << line << endl;
            //else 
				rfile << line << "bm " << bm << "; " << id << ";\n";
        }
		//*/
    }
    cout << total_depth/i << " " 
	<< total_nodes + total_qnodes << "K ["
	<< total_nodes << "K " << total_qnodes << "K ("
    << 100*total_qnodes/(total_nodes+total_qnodes) << "%)] "
    << 100*total_fh1/total_fhn << "%" << endl;
    ofile << "#" << total_depth/i << " "
	<< (clock()-start) << " "
	<< total_nodes + total_qnodes << "K ["
    << total_nodes << "K " << total_qnodes << "K ("
    << 100*total_qnodes/(total_nodes+total_qnodes) << "%)] " 
    << 100*total_fh1/total_fhn << "%  "
    << (float)total_abf/i;
    infile.close();
    ofile.close();
    rfile.close();
    //mfile.close();
	return 1;
}

