#ifndef weight_included
#define weight_included

//#define DEBUGe
#define PHASHING

//#define OPPOSITION(x) ((minors[x]+majors[x]*3)/26)

extern unsigned int main_hash_entries;
extern unsigned int pawn_hash_entries;

extern int ks_defect;
extern int ks_exponent;

extern int max_pos_value;
extern int max_pos_gain;

extern int ext_base;
extern int ext_check;
extern int ext_p27th;
extern int ext_mate;
extern int ext_1reply;
extern int ext_recap;

extern int forked_piece;
extern int hanging_piece;

extern int premature_queen;

extern int rook_restricted;
extern int rook_trapped;
extern int rook_on_7th;
extern int rook_connected;
extern int rook_on_open;
extern int rook_on_hopen;
extern int rook_behind_passed;

extern int bishop_trapped;
extern int bishop_restricted;
extern int bishop_pair;

extern int space;

extern int isolated_pawn;
extern int doubled_pawn;
extern int immobile_pawn;
extern int weak_pawn;
extern int end_pawn;

extern int unmoved_piece;

extern int kings2war;

extern int shield0;
extern int shield1;
extern int shield2;
extern int shield3;
extern int shield4;
extern int shield5;
extern int shield6;
extern int ropenbyking;
extern int rhopenbyking;
extern int no_escape;

#endif
